﻿using System;

namespace Vita.Domain.Accounting
{
    public class CreditIsIncreaseBalanceStrategy : IAccountBalanceChangeStrategy
    {
        public Money Apply(Money amount)
        {
            if (amount.Value < 0) throw new ArgumentOutOfRangeException("amount", amount.Value, "Values must be absolute (i.e. >= 0).");

            return amount;
        }

        public Money ApplyCredit(Money amount)
        {
            if (amount.Value < 0) throw new ArgumentOutOfRangeException("amount", amount.Value, "Values must be absolute (i.e. >= 0).");

            return new Money(amount.Value);
        }

        public Money ApplyDebit(Money amount)
        {
            if (amount.Value < 0) throw new ArgumentOutOfRangeException("amount", amount.Value, "Values must be absolute (i.e. >= 0).");

            return new Money(0 - amount.Value);
        }
    }
}