﻿using System;
using Regalo.Core;

namespace Vita.Domain.Accounting
{
    public class FundsTransferRequested : Event
    {
        public Guid  FundsTransferId      { get; set; }
        public Guid  SourceAccountId      { get; set; }
        public Guid  DestinationAccountId { get; set; }
        public Money Amount               { get; set; }

        public FundsTransferRequested(Guid fundsTransferId, Guid sourceAccountId, Guid destinationAccountId, Money amount)
        {
            FundsTransferId      = fundsTransferId;
            SourceAccountId      = sourceAccountId;
            DestinationAccountId = destinationAccountId;
            Amount               = amount;
        }

        protected bool Equals(FundsTransferRequested other)
        {
            return Equals(Amount, other.Amount) && DestinationAccountId.Equals(other.DestinationAccountId) && FundsTransferId.Equals(other.FundsTransferId) && SourceAccountId.Equals(other.SourceAccountId);
        }

        public override bool Equals(object obj)
        {
            if (ReferenceEquals(null, obj)) return false;
            if (ReferenceEquals(this, obj)) return true;
            if (obj.GetType() != this.GetType()) return false;
            return Equals((FundsTransferRequested)obj);
        }

        public override int GetHashCode()
        {
            unchecked
            {
                var hashCode = (Amount != null ? Amount.GetHashCode() : 0);
                hashCode = (hashCode * 397) ^ DestinationAccountId.GetHashCode();
                hashCode = (hashCode * 397) ^ FundsTransferId.GetHashCode();
                hashCode = (hashCode * 397) ^ SourceAccountId.GetHashCode();
                return hashCode;
            }
        }
    }
}