using System;
using Regalo.Core;

namespace Vita.Domain.Accounting
{
    public class OpenAccountHandler : ICommandHandler<OpenAccount>
    {
        private readonly IRepository<Account> _repository;
        private readonly IEventBus _eventBus;

        public OpenAccountHandler(IRepository<Account> repository, IEventBus eventBus)
        {
            _repository = repository;
            _eventBus = eventBus;
        }

        public void Handle(OpenAccount command)
        {
            var account = new Account();
            const string accountHolderName = "Hardcoded"; // would normally query readstore with id
            var id = Guid.NewGuid();
            account.Open(id, command.AccountType, command.AccountHolderId, accountHolderName, command.AccountName, command.OpeningBalance);
            var events = account.GetUncommittedEvents();
            _repository.Save(account);
            _eventBus.Publish(events);
        }
    }
}