using System;

namespace Vita.Domain
{
    public abstract class GuidProvider
    {
        private static GuidProvider _current;

        public static GuidProvider Current
        {
            get { return _current ?? (_current = new DefaultGuidProvider()); }
            set
            {
                if (value == null) throw new ArgumentNullException("value");
                _current = value;
            }
        }

        public static void ResetDefaults()
        {
            _current = null;
        }

        public abstract Guid NewId();
   }
}