using System;

namespace Vita.Domain
{
    public abstract class TimeWithOffsetProvider
    {
        private static TimeWithOffsetProvider _current;

        public static TimeWithOffsetProvider Current
        {
            get { return _current ?? (_current = new DefaultTimeWithOffsetProvider()); }
            set
            {
                if (value == null) throw new ArgumentNullException("value");
                _current = value;
            }
        }

        public static void ResetDefaults()
        {
            _current = null;
        }

        public abstract DateTimeOffset Now { get; }
    }
}